// ==============================================================
//                 ORBITER MODULE: MBA
//                  Part of the ORBITER SDK
//          Copyright (C) 2002-2004 Martin Schweiger
//                   All rights reserved
//
// MBA.cpp
// Control module for MBA vessel class
//

// ==============================================================
#define STRICT
#define ORBITER_MODULE
#define DOORCLOSE				1	
#define AIRLOCKCLOSE 			2	
#define ELEVATOR 				3
#include "orbitersdk.h"
#include "MBA31.h"
#include "ColorNames.h"
#include "OrbiterSoundSDK35.h"
#include "MARSBASEMESH3.1.h"
VISHANDLE MainExternalMeshVisual = 0;



void MBA::clbkPostCreation (void)

{

MARSBASEID=ConnectToOrbiterSoundDLL3(GetHandle());
ReplaceStockSound3(MARSBASEID,"Sound\\Vessel\\MARSBASE\\ambient.wav",	REPLACE_COCKPIT_AMBIENCE_1);
RequestLoadVesselWave3(MARSBASEID,AIRLOCKCLOSE,"Sound\\Vessel\\MARSBASE\\airlockclose.wav",BOTHVIEW_FADED_FAR);
RequestLoadVesselWave3(MARSBASEID,ELEVATOR,"Sound\\Vessel\\MARSBASE\\elevatorupdown.wav",BOTHVIEW_FADED_FAR);
RequestLoadVesselWave3(MARSBASEID,DOORCLOSE,"Sound\\Vessel\\MARSBASE\\doorclose.wav",BOTHVIEW_FADED_FAR);

SoundOptionOnOff3(MARSBASEID,PLAYMAINTHRUST,FALSE);

SoundOptionOnOff3(MARSBASEID,PLAYHOVERTHRUST,FALSE);
SoundOptionOnOff3(MARSBASEID,PLAYATTITUDETHRUST,FALSE);

SoundOptionOnOff3(MARSBASEID,PLAYCOUNTDOWNWHENTAKEOFF,FALSE);

SoundOptionOnOff3(MARSBASEID,PLAYCABINAIRCONDITIONING,FALSE);

SoundOptionOnOff3(MARSBASEID,PLAYCABINRANDOMAMBIANCE,TRUE);

SoundOptionOnOff3(MARSBASEID,PLAYRADIOATC,FALSE);

SoundOptionOnOff3(MARSBASEID,DISPLAYTIMER,FALSE);
}// Constructor
void MBA::SetUMMUAirlockPos(void)
{
	int AirlockStatus=Crew.GetAirlockDoorState();
	Crew.SetActiveDockForTransfer(iActiveDockNumber);
	
	switch(iActiveDockNumber)
	{
	case 0:	//AIRLOCK1
Crew.DefineAirLockShape(AirlockStatus,-76,-71,-23,2,617,624);			
		Crew.SetMembersPosRotOnEVA(_V(-73.89719,-19.971,620.3109),_V(0,3,0));	
	
			doorselected=0;
		break;
	case 1:	//AIRLOCK2
		Crew.DefineAirLockShape(AirlockStatus,-692,-675,-23,2,130,160);		
	Crew.SetMembersPosRotOnEVA(_V(-683.8657,-19.971,145.6911),_V(0,0,0));
	doorselected=1;
		break;
	case 2:	//AIRLOCK3
Crew.DefineAirLockShape(AirlockStatus,-687,-671,-23,2,-360,-350);			
		Crew.SetMembersPosRotOnEVA(_V(-678.3786,-19.971,-356.2914),_V(0,3,0));	
	
			doorselected=2;
		break;
			case 3:	//AIRLOCK4
Crew.DefineAirLockShape(AirlockStatus,149,166,-23,2,-700,-690);			
		Crew.SetMembersPosRotOnEVA(_V( 156.7226,-19.971,-694.5609),_V(0,3,0));	
	
			doorselected=3;
		break;
			case 4:	//AIRLOCK5
Crew.DefineAirLockShape(AirlockStatus,772,788,-23,2,-55,-40);			
		Crew.SetMembersPosRotOnEVA(_V( 781.4486,-19.971,-47.12168),_V(0,3,0));	
	
			doorselected=4;
		break;
	}


	
	}

void MBA::SelectCockpitView (int CAM)
{

     switch (CAM) {
  case 0:  //ext
          SetCameraDefaultDirection (_V(0,0,1));
          SetCameraOffset (_V(15,150,42));
          break;
 case 1:  //PAD1
          SetCameraDefaultDirection (_V(0,0,1));
          SetCameraOffset (_V(-11.08,-12,578.06));
          break;
 case 2:  //PAD2
          SetCameraDefaultDirection (_V(1,0,0));
          SetCameraOffset (_V(-683.81,-12,69.81));
          break;
 case 3:  //PAD3
          SetCameraDefaultDirection (_V(1,0,0));
          SetCameraOffset (_V(-678.70,-12,-280.51));
          break;
 case 4:  //PAD4
          SetCameraDefaultDirection (_V(-1,0,0));
          SetCameraOffset (_V(157.03,-12,-619.50));
          break;
 case 5:  //PAD5
          SetCameraDefaultDirection (_V(-1,0,0));
          SetCameraOffset (_V(781.51,-12,28.08));
          break;
 case 6:  //PAD6
          SetCameraDefaultDirection (_V(1,0,0));
          SetCameraOffset (_V(-15,-12,845));
          break;
case 7:  //CARGOBAY
          SetCameraDefaultDirection (_V(0,0,1));
          SetCameraOffset (_V(-10,-15,727));
          break;

      }
            }

MBA::MBA (OBJHANDLE hObj, int fmodel)
: VESSEL2 (hObj, fmodel)


{
  whichap           = 1;
	LIFT_SPEED =.25;
	ELEV_SPEED =.2;
LP1D_status      = HATCH_UP;
LP1D_proc        = 0.0;	
LP2D_status      = HATCH_UP;
LP2D_proc        = 0.0;	
LP3D_status      = HATCH_UP;
LP3D_proc        = 0.0;	
LP4D_status      = HATCH_UP;
LP4D_proc        = 0.0;	
LP5D_status      = HATCH_UP;
LP5D_proc        = 0.0;	
LP5_status      = HATCH_UP;
LP5_proc        = 0.0;
LP1_status      = HATCH_UP;
LP1_proc        = 0.0;
LP2_status      = HATCH_UP;
LP2_proc        = 0.0;
LP3_status      = HATCH_UP;
LP3_proc        = 0.0;
LP4_status      = HATCH_UP;
LP4_proc        = 0.0;
APSel=0;
ULP1D_status      = HATCH_UP;
ULP1D_proc        = 0.0;	
ULP2D_status      = HATCH_UP;
ULP2D_proc        = 0.0;	
ULP3D_status      = HATCH_UP;
ULP3D_proc        = 0.0;	
ULP4D_status      = HATCH_UP;
ULP4D_proc        = 0.0;	
ULP5D_status      = HATCH_UP;
ULP5D_proc        = 0.0;
DD4_status      = HATCH_UP;
DD4_proc        = 0.0;
DD0_status      = HATCH_UP;
DD0_proc        = 0.0;
DD1_status      = HATCH_UP;
DD1_proc        = 0.0;
DD2_status      = HATCH_UP;
DD2_proc        = 0.0;
DD3_status      = HATCH_UP;
DD3_proc        = 0.0;
DD4_status      = HATCH_UP;
DD4_proc        = 0.0;
DD5_status      = HATCH_UP;
DD5_proc        = 0.0;
DD6_status      = HATCH_UP;
DD6_proc        = 0.0;
CARGOBAY_status      = HATCH_UP;
CARGOBAY_proc        = 0.0;
BAYFACTOR=17.281;
LP5_INT_POS=-21.143;
LP1_INT_POS=-21.143;
LP2_INT_POS=-21.143;
LP3_INT_POS=-21.143;
LP4_INT_POS=-21.143;
MAX_GRAP_DIST=100;
CAM = 0;
	DefineAnimations ();
	
}


void MBA::clbkSetClassCaps (FILEHANDLE cfg)
{
	// physical specs
	SetSize (1623);
	SetEmptyMass (1500000000000);
	SetCW (0.3, 0.3, 0.6, 0.9);
	SetWingAspect (0.7);
	SetWingEffectiveness (2.5);
	SetCrossSections (_V(29135.87,564320.83,29280.31));
	SetRotDrag (_V(0.6,0.6,0.35));
	if (GetFlightModel() >= 1) {
		SetPitchMomentScale (1e-4);
		SetBankMomentScale (1e-4);
	}
	SetPMI (_V(61384.83,147645.09,86588.43));
	SetTrimScale (0.05);
	SetCameraOffset (_V(15,150,42));
SetSurfaceFrictionCoeff (0.07, 0.4);
//SetClipRadius (100);
SetTouchdownPoints  (_V(0,-21.146,290), _V(-240,-21.146,-250), _V(240,-21.146,-250)); 
EnableTransponder (true);
//DOCKHANDLE PAD1=CreateDock (_V(-7.74,5.259,585.2), _V(0,1,0), _V(0,0,1));
//DOCKHANDLE PAD2=CreateDock (_V(-683.23,5.259, 76.82), _V(0,1,0), _V(0,0,1));
//DOCKHANDLE PAD3=CreateDock (_V(-679.95 ,5.259,-273.49), _V(0,1,0), _V(0,0,1));
//DOCKHANDLE PAD4=CreateDock (_V( 152.74,5.259, -612.11), _V(0,1,0), _V(0,0,1));
//DOCKHANDLE PAD5=CreateDock (_V(783.46 ,5.259,35.48), _V(0,1,0), _V(0,0,1));


LP1 = CreateAttachment (false, _V(-11.08,-21.143,578.06),_V(0,1,0),_V(0,0,1),"1",false);
LP2 = CreateAttachment (false, _V(-681.83,-21.143,69.81  ),_V(0,1,0),_V(0,0,1),"2",false);
LP3 = CreateAttachment (false, _V(-678.70, -21.143,-280.51),_V(0,1,0),_V(0,0,1),"3",false);
LP4 = CreateAttachment (false, _V(157.03, -21.143, -619.50),_V(0,1,0),_V(0,0,1),"4",false);
LP5 = CreateAttachment (false, _V(781.51,-21.143, 28.08),_V(0,1,0),_V(0,0,1),"5",false);
 


                                   
 
   static VECTOR3 APbeaconcol[7] = {{1, 1, 1},
                                    {1, 1, 1},
                                   {1, 1, 1},
                                 {1, 1, 1},
                                   {1, 1, 1},
                                   {1, 1, 1},
                                   {1, 1, 1},
                                   
                                  };

    for ( i = 0; i < 7; i++) {
        APbeacon[i].shape = BEACONSHAPE_STAR;
        APbeacon[i].pos = APbeaconpos+i;
        APbeacon[i].col = APbeaconcol+i;
        APbeacon[i].size = 3;
        APbeacon[i].falloff =  0.4;
        APbeacon[i].period = 0.8;
        APbeacon[i].duration = 0.3;
        APbeacon[i].tofs = (6-i)*0.2;
        APbeacon[i].active = false;
        AddBeacon (APbeacon+i);
    }

        APbeacon[0].active = true;
   



	


// ==============================================================
// Overloaded callback functions
// ==============================================================
//PAD capture point

 
    LP1_pos.x =  -11.08;
    LP1_pos.y = -21.143;
    LP1_pos.z = 578.06;
  
LP2_pos.x =   -683.81;
    LP2_pos.y = -21.143;
    LP2_pos.z = 69.81;
    
LP3_pos.x =   -678.70;
    LP3_pos.y = -21.143;
    LP3_pos.z = -280.51;  
   
LP4_pos.x =   157.03;
    LP4_pos.y =-21.143;
    LP4_pos.z = -619.50;
      
LP5_pos.x =   781.51;
    LP5_pos.y = -21.143;
    LP5_pos.z =  28.08;        
   



// ************************************************
	// Call clbkSetClassCaps_UMMU and select a member
	SelectedUmmuMember=0;
	clbkSetClassCaps_UMMu();	
    
   
	                             
	
	// visual specs
			
// visual specs
SetMeshVisibilityMode (AddMesh (oapiLoadMeshGlobal ("MARSBASE3.20")), MESHVIS_ALWAYS | MESHVIS_EXTPASS); //Main ship mesh

}

    

// =======================================================
// UMMU Class Caps
// =======================================================
void MBA::clbkSetClassCaps_UMMu(void)
{
	// InitUmmu
	UmmuSdKInitReturnCode=Crew.InitUmmu(GetHandle());	
	

	// GetUserUMmuVersion
	float UMmuVersion=Crew.GetUserUMmuVersion();
// DefineAirLockShape
	Crew.DefineAirLockShape(FALSE,-76,-71,-23,2,617,624);			// Airlock open, 2 meter large 4 meter high 6 meter long (vessel local coordinate)

	// SetMembersPositionOrientationOnEVA
	Crew.SetMembersPosRotOnEVA(_V(-73.89719,-19.971,620.3109),_V(0,3,0));	// 3 meters in front of ship (z) facing direction of ship (vessel local coordinate)

	
	//maximum seat available in this ship
	Crew.SetMaxSeatAvailableInShip(2);

	//default crew member used when the ship is spawned by Orbiter's scenerio editor. 
	Crew.AddCrewMember("Paul Roper",41,65,74,"Capt");	//(for name and id a-z A-Z 0-9 characters only)
	Crew.AddCrewMember("Frank Craig",27,67,55,"Eng");	//(for name and id a-z A-Z 0-9 characters only)
	Crew.AddCrewMember("Craig Collins",25,70,45,"Ast");	//(for name and id a-z A-Z 0-9 characters only)
	Crew.AddCrewMember("Doug Jackson",45,70,45,"Doc" );	//(for name and id a-z A-Z 0-9 characters only)
	Crew.AddCrewMember("Keith Ford",45,70,45,"Sec");	//(for name and id a-z A-Z 0-9 characters only)
	Crew.AddCrewMember("Paul Foster",45,70,45,"Sci" );	//(for name and id a-z A-Z 0-9 characters only)
//change mesh
	
	// see function "SendFocusScreenMessage"
	strcpy(cOurMessage,"");
	//change mesh
	//Crew.SetAlternateMeshToUseForEVASpacesuit("ummu");
}

void MBA::clbkPostStep(double simt, double simdt, double mjd)
{
	//---------------------------------------------------------------------------
	// ProcessUniversalMMu
	int ReturnCode=Crew.ProcessUniversalMMu();
	switch(ReturnCode)
	{
		case UMMU_TRANSFERED_TO_OUR_SHIP: 
			sprintf(SendFocusScreenMessage(),"%s \"%s\" aged %i was transfered to our ship",Crew.GetCrewMiscIdByName(Crew.GetLastEnteredCrewName()),Crew.GetLastEnteredCrewName(),Crew.GetCrewAgeByName(Crew.GetLastEnteredCrewName()));
			break;
		case UMMU_RETURNED_TO_OUR_SHIP:
			sprintf(SendFocusScreenMessage(),"%s \"%s\" aged %i entered into our ship",Crew.GetCrewMiscIdByName(Crew.GetLastEnteredCrewName()),Crew.GetLastEnteredCrewName(),Crew.GetCrewAgeByName(Crew.GetLastEnteredCrewName()));
			break;
	}

	//----------------------------------------------------------------------------
	// SetCrewMemberPulseBySlotNumber
	if(GroundContact()==TRUE)
	{
		// we check vertical speed
		int I;
		VECTOR3 vHorizonAirspeedVector={0};
		GetHorizonAirspeedVector (vHorizonAirspeedVector);
		double VertSpeed		=vHorizonAirspeedVector.y;
		if(VertSpeed<-3)
		{
			// we touched ground with more than -3 m/s, sorry dude, time to kill you all :(
			for(I=0;I<Crew.GetCrewTotalNumber();I++)
			{
				Crew.SetCrewMemberPulseBySlotNumber(I,0);	// set cardiac pulse to zero
			}
			strcpy(SendFocusScreenMessage(),"Oooh no ! Crash - All crew aboard killed");
		}
	}

	//----------------------------------------------------------------------------
	// see function "SendFocusScreenMessage" below for explaination.
	if(GetHandle()==oapiGetFocusObject())
	{
		strcpy(oapiDebugString(),cOurMessage);
	}

//PADDOORS

if ((APSel==0)&&(ULP1D_proc==1))//pad is selected and upper door open
{

if (LP1_status >= HATCH_RAISING) {

		double da = simdt * ELEV_SPEED;
		if (LP1_status == HATCH_RAISING) {
			if (LP1_proc > 0.0) LP1_proc = max (0.0, LP1_proc-da);
			else                LP1_status = HATCH_UP;
		} else {
			if (LP1_proc < 1.0) LP1_proc = min (1.0, LP1_proc+da);
			else                LP1_status = HATCH_DOWN;
		}
		SetAnimation (anim_LP1, LP1_proc);
	

}}

if ((APSel==1)&(ULP2D_proc==1)){

if (LP2_status >= HATCH_RAISING) {
		double da = simdt * ELEV_SPEED;
		if (LP2_status == HATCH_RAISING) {
			if (LP2_proc > 0.0) LP2_proc = max (0.0, LP2_proc-da);
			else                LP2_status = HATCH_UP;
		} else {
			if (LP2_proc < 1.0) LP2_proc = min (1.0, LP2_proc+da);
			else                LP2_status = HATCH_DOWN;
		}
		SetAnimation (anim_LP2, LP2_proc);
	

}}

if ((APSel==2)&(ULP3D_proc==1)){

if (LP3_status >= HATCH_RAISING) {
		double da = simdt * ELEV_SPEED;
		if (LP3_status == HATCH_RAISING) {
			if (LP3_proc > 0.0) LP3_proc = max (0.0, LP3_proc-da);
			else                LP3_status = HATCH_UP;
		} else {
			if (LP3_proc < 1.0) LP3_proc = min (1.0, LP3_proc+da);
			else                LP3_status = HATCH_DOWN;
		}
		SetAnimation (anim_LP3, LP3_proc);


}}

if ((APSel==3)&(ULP4D_proc==1))
{
if (LP4_status >= HATCH_RAISING) {
		double da = simdt * ELEV_SPEED;
		if (LP4_status == HATCH_RAISING) {
			if (LP4_proc > 0.0) LP4_proc = max (0.0, LP4_proc-da);
			else                LP4_status = HATCH_UP;
		} else {
			if (LP4_proc < 1.0) LP4_proc = min (1.0, LP4_proc+da);
			else                LP4_status = HATCH_DOWN;
		}
		SetAnimation (anim_LP4, LP4_proc);

}}

if ((APSel==4)&(ULP5D_proc==1))
{
if (LP5_status >= HATCH_RAISING) {
		double da = simdt * ELEV_SPEED;
		if (LP5_status == HATCH_RAISING) {
			if (LP5_proc > 0.0) LP5_proc = max (0.0, LP5_proc-da);
			else                LP5_status = HATCH_UP;
		} else {
			if (LP5_proc < 1.0) LP5_proc = min (1.0, LP5_proc+da);
			else                LP5_status = HATCH_DOWN;
		}
		SetAnimation (anim_LP5, LP5_proc);
	

}}
//PADUPPERDOORS
if (APSel==0){

if (ULP1D_status >= HATCH_RAISING) {
		double da = simdt * LIFT_SPEED;
		if (ULP1D_status == HATCH_RAISING) {
			if (ULP1D_proc > 0.0) ULP1D_proc = max (0.0, ULP1D_proc-da);
			else                ULP1D_status = HATCH_UP;
		} else {
			if (ULP1D_proc < 1.0) ULP1D_proc = min (1.0, ULP1D_proc+da);
			else                ULP1D_status = HATCH_DOWN;
		}
		SetAnimation (anim_ULP1DOOR1, ULP1D_proc);
	SetAnimation (anim_ULP1DOOR2, ULP1D_proc);

}}

if (APSel==1){

if (ULP2D_status >= HATCH_RAISING) {
		double da = simdt * LIFT_SPEED;
		if (ULP2D_status == HATCH_RAISING) {
			if (ULP2D_proc > 0.0) ULP2D_proc = max (0.0, ULP2D_proc-da);
			else                LP2D_status = HATCH_UP;
		} else {
			if (ULP2D_proc < 1.0) ULP2D_proc = min (1.0, ULP2D_proc+da);
			else                ULP2D_status = HATCH_DOWN;
		}
		SetAnimation (anim_ULP2DOOR1, ULP2D_proc);
		SetAnimation (anim_ULP2DOOR2, ULP2D_proc);


}}

if (APSel==2){

if (ULP3D_status >= HATCH_RAISING) {
		double da = simdt * LIFT_SPEED;
		if (ULP3D_status == HATCH_RAISING) {
			if (ULP3D_proc > 0.0) ULP3D_proc = max (0.0, ULP3D_proc-da);
			else                ULP3D_status = HATCH_UP;
		} else {
			if (ULP3D_proc < 1.0) ULP3D_proc = min (1.0, ULP3D_proc+da);
			else                ULP3D_status = HATCH_DOWN;
		}
		SetAnimation (anim_ULP3DOOR1, ULP3D_proc);
	SetAnimation (anim_ULP3DOOR2, ULP3D_proc);

}}

if (APSel==3){

if (ULP4D_status >= HATCH_RAISING) {
		double da = simdt * LIFT_SPEED;
		if (ULP4D_status == HATCH_RAISING) {
			if (ULP4D_proc > 0.0) ULP4D_proc = max (0.0, ULP4D_proc-da);
			else               ULP4D_status = HATCH_UP;
		} else {
			if (ULP4D_proc < 1.0) ULP4D_proc = min (1.0, ULP4D_proc+da);
			else                ULP4D_status = HATCH_DOWN;
		}
		SetAnimation (anim_ULP4DOOR1, ULP4D_proc);
	SetAnimation (anim_ULP4DOOR2, ULP4D_proc);

}}

if (APSel==4){

if (ULP5D_status >= HATCH_RAISING) {
		double da = simdt * LIFT_SPEED;
		if (ULP5D_status == HATCH_RAISING) {
			if (ULP5D_proc > 0.0) ULP5D_proc = max (0.0, ULP5D_proc-da);
			else                ULP5D_status = HATCH_UP;
		} else {
			if (ULP5D_proc < 1.0) ULP5D_proc = min (1.0, ULP5D_proc+da);
			else                ULP5D_status = HATCH_DOWN;
		}
		SetAnimation (anim_ULP5DOOR1, ULP5D_proc);
	SetAnimation (anim_ULP5DOOR2, ULP5D_proc);

}}
//PADsideDOORS
if (APSel==0){

if (LP1D_status >= HATCH_RAISING) {
		double da = simdt * LIFT_SPEED;
		if (LP1D_status == HATCH_RAISING) {
			if (LP1D_proc > 0.0) LP1D_proc = max (0.0, LP1D_proc-da);
			else                LP1D_status = HATCH_UP;
		} else {
			if (LP1D_proc < 1.0) LP1D_proc = min (1.0, LP1D_proc+da);
			else                LP1D_status = HATCH_DOWN;
		}
		SetAnimation (anim_LP1DOOR1, LP1D_proc);
	SetAnimation (anim_LP1DOOR2, LP1D_proc);

	
}}

if (APSel==1){

if (LP2D_status >= HATCH_RAISING) {
		double da = simdt * LIFT_SPEED;
		if (LP2D_status == HATCH_RAISING) {
			if (LP2D_proc > 0.0) LP2D_proc = max (0.0, LP2D_proc-da);
			else                LP2D_status = HATCH_UP;
		} else {
			if (LP2D_proc < 1.0) LP2D_proc = min (1.0, LP2D_proc+da);
			else                LP2D_status = HATCH_DOWN;
		}
		SetAnimation (anim_LP2DOOR1, LP2D_proc);
		SetAnimation (anim_LP2DOOR2, LP2D_proc);
	

}}

if (APSel==2){

if (LP3D_status >= HATCH_RAISING) {
		double da = simdt * LIFT_SPEED;
		if (LP3D_status == HATCH_RAISING) {
			if (LP3D_proc > 0.0) LP3D_proc = max (0.0, LP3D_proc-da);
			else                LP3D_status = HATCH_UP;
		} else {
			if (LP3D_proc < 1.0) LP3D_proc = min (1.0, LP3D_proc+da);
			else                LP3D_status = HATCH_DOWN;
		}
		SetAnimation (anim_LP3DOOR1, LP3D_proc);
	SetAnimation (anim_LP3DOOR2, LP3D_proc);

}}

if (APSel==3){

if (LP4D_status >= HATCH_RAISING) {
		double da = simdt * LIFT_SPEED;
		if (LP4D_status == HATCH_RAISING) {
			if (LP4D_proc > 0.0) LP4D_proc = max (0.0, LP4D_proc-da);
			else                LP4D_status = HATCH_UP;
		} else {
			if (LP4D_proc < 1.0) LP4D_proc = min (1.0, LP4D_proc+da);
			else                LP4D_status = HATCH_DOWN;
		}
		SetAnimation (anim_LP4DOOR1, LP4D_proc);
	SetAnimation (anim_LP4DOOR2, LP4D_proc);

}}

if (APSel==4){

if (LP5D_status >= HATCH_RAISING) {
		double da = simdt * LIFT_SPEED;
		if (LP5D_status == HATCH_RAISING) {
			if (LP5D_proc > 0.0) LP5D_proc = max (0.0, LP5D_proc-da);
			else                LP5D_status = HATCH_UP;
		} else {
			if (LP5D_proc < 1.0) LP5D_proc = min (1.0, LP5D_proc+da);
			else                LP5D_status = HATCH_DOWN;
		}
		SetAnimation (anim_LP5DOOR1, LP5D_proc);
	SetAnimation (anim_LP5DOOR2, LP5D_proc);

}}
//hangarairlockdoors
if (DD0_status >= HATCH_RAISING) {
		double da = simdt * LIFT_SPEED;
		if (DD0_status == HATCH_RAISING) {
			if (DD0_proc > 0.0) DD0_proc = max (0.0, DD0_proc-da);
			else                DD0_status = HATCH_UP;
		} else {
			if (DD0_proc < 1.0) DD0_proc = min (1.0, DD0_proc+da);
			else                DD0_status = HATCH_DOWN;
		}
		SetAnimation (anim_DD0, DD0_proc);
	

}


if (DD1_status >= HATCH_RAISING) {
		double da = simdt * LIFT_SPEED;
		if (DD1_status == HATCH_RAISING) {
			if (DD1_proc > 0.0) DD1_proc = max (0.0, DD1_proc-da);
			else                DD1_status = HATCH_UP;
		} else {
			if (DD1_proc < 1.0) DD1_proc = min (1.0, DD1_proc+da);
			else                DD1_status = HATCH_DOWN;
		}
	SetAnimation (anim_DD1, DD1_proc);

}


if (DD2_status >= HATCH_RAISING) {
		double da = simdt * LIFT_SPEED;
		if (DD2_status == HATCH_RAISING) {
			if (DD2_proc > 0.0) DD2_proc = max (0.0, DD2_proc-da);
			else                DD2_status = HATCH_UP;
		} else {
			if (DD2_proc < 1.0) DD2_proc = min (1.0, DD2_proc+da);
			else                DD2_status = HATCH_DOWN;
		}
		SetAnimation (anim_DD2, DD2_proc);
	

}


if (DD3_status >= HATCH_RAISING) {
		double da = simdt * LIFT_SPEED;
		if (DD3_status == HATCH_RAISING) {
			if (DD3_proc > 0.0) DD3_proc = max (0.0, DD3_proc-da);
			else                DD3_status = HATCH_UP;
		} else {
			if (DD3_proc < 1.0) DD3_proc = min (1.0, DD3_proc+da);
			else                DD3_status = HATCH_DOWN;
		}
		SetAnimation (anim_DD3, DD3_proc);

}


if (DD4_status >= HATCH_RAISING) {
		double da = simdt * LIFT_SPEED;
		if (DD4_status == HATCH_RAISING) {
			if (DD4_proc > 0.0) DD4_proc = max (0.0, DD4_proc-da);
			else                DD4_status = HATCH_UP;
		} else {
			if (DD4_proc < 1.0) DD4_proc = min (1.0, DD4_proc+da);
			else                DD4_status = HATCH_DOWN;
		}
		SetAnimation (anim_DD4, DD4_proc);


}
//cargobay

if (CARGOBAY_status >= HATCH_RAISING) {
		double da = simdt * LIFT_SPEED;
		if (CARGOBAY_status == HATCH_RAISING) {
			if (CARGOBAY_proc > 0.0) CARGOBAY_proc = max (0.0, CARGOBAY_proc-da);
			else                CARGOBAY_status = HATCH_UP;
		} else {
			if (CARGOBAY_proc < 1.0) CARGOBAY_proc = min (1.0, CARGOBAY_proc+da);
			else                CARGOBAY_status = HATCH_DOWN;
		}
SetAnimation (anim_CARGOBAYDOOR1, CARGOBAY_proc);
	SetAnimation (anim_CARGOBAYDOOR, CARGOBAY_proc);
		SetAnimation (anim_CARGOBAYDOORA, CARGOBAY_proc);


}
//sprintf(oapiDebugString(),"GEAR_proc%2.2f ",CARGOBAY_proc);
//MOVE ATTACHMENT POINTS

{LP1_pos.y=LP1_INT_POS+(LP1_proc*BAYFACTOR);
SetAttachmentParams(LP1,LP1_pos,_V(0,1,0),_V(0,0,1));

}

{LP2_pos.y=LP2_INT_POS+(LP2_proc*BAYFACTOR);
SetAttachmentParams(LP2,LP2_pos,_V(0,1,0),_V(0,0,1));

}

{LP3_pos.y=LP3_INT_POS+(LP3_proc*BAYFACTOR);
SetAttachmentParams(LP3,LP3_pos,_V(0,1,0),_V(0,0,1));

}

{LP4_pos.y=LP4_INT_POS+(LP4_proc*BAYFACTOR);
SetAttachmentParams(LP4,LP4_pos,_V(0,1,0),_V(0,0,1));

}

{LP5_pos.y=LP5_INT_POS+(LP5_proc*BAYFACTOR);
SetAttachmentParams(LP5,LP5_pos,_V(0,1,0),_V(0,0,1));

}


APbeaconpos[0] = LP1_pos;
APbeaconpos[1] = LP2_pos;
APbeaconpos[2] = LP3_pos;
APbeaconpos[3] = LP4_pos;
APbeaconpos[4] = LP5_pos;


}
void MBA::DefineAnimations(void)
{

//PAD
  	static UINT EGrp15[2] = {GRP_pad1,GRP_pad1a };//pad1
   static MGROUP_TRANSLATE landpad1 (0,EGrp15, 2, _V(0,17.281,0));
   
   anim_LP1 = CreateAnimation (0);      
  AddAnimationComponent  (anim_LP1, 0, 1, &landpad1);   


  	static UINT EGrp16[2] = {GRP_pad2,GRP_pad2a};//pad2
   static MGROUP_TRANSLATE landpad2 (0,EGrp16, 2, _V(0,17.281,0));
   
   anim_LP2 = CreateAnimation (0);      
  AddAnimationComponent  (anim_LP2, 0, 1, &landpad2);   
    

  	static UINT EGrp17[2] = {GRP_pad3,GRP_pad3a};//pad3
   static MGROUP_TRANSLATE landpad3 (0,EGrp17, 2, _V(0,17.2815,0));
   
   anim_LP3 = CreateAnimation (0);      
  AddAnimationComponent  (anim_LP3, 0, 1, &landpad3);   

  	static UINT EGrp18[2] = {GRP_pad4,GRP_pad4a};//pad4
   static MGROUP_TRANSLATE landpad4 (0,EGrp18, 2, _V(0,17.281,0));
   
   anim_LP4 = CreateAnimation (0);      
  AddAnimationComponent  (anim_LP4, 0, 1, &landpad4);   
    

  	static UINT EGrp19[2] = {GRP_pad5,GRP_pad5a};//pad5
   static MGROUP_TRANSLATE landpad5 (0,EGrp19, 3, _V(0,17.281,0));
   
   anim_LP5 = CreateAnimation (0);      
  AddAnimationComponent  (anim_LP5, 0, 1, &landpad5); 
 
//SIDEPADDOOR
  	static UINT EGrp20[3] = {GRP_pad1door1,GRP_pad1door1a, GRP_pad1door1b    };//pad1
  static MGROUP_ROTATE landpad1door1 (0,EGrp20, 3, _V(-11.139,0,578.091), _V(0,1,0), (float)(-30*RAD)); 
   
   anim_LP1DOOR1 = CreateAnimation (0);      
  AddAnimationComponent  (anim_LP1DOOR1, 0, 1, &landpad1door1);   

//SIDEPADDOOR

  	static UINT EGrp21[3] = {GRP_pad1door2,GRP_pad1door2a, GRP_pad1door2b };//pad1
  static MGROUP_ROTATE landpad1door2 (0,EGrp21, 3, _V(-11.139,0,578.091), _V(0,1,0), (float)(30*RAD)); 
   
   anim_LP1DOOR2 = CreateAnimation (0);      
  AddAnimationComponent  (anim_LP1DOOR2, 0, 1, &landpad1door2);     	   

//SIDEPADDOOR

  	static UINT EGrp22[3] = {GRP_pad2door1,GRP_pad2door1a, GRP_pad2door1b };//pad2
   static MGROUP_ROTATE landpad2door1 (0,EGrp22, 3, _V(-683.81,0,69.81), _V(0,1,0), (float)(30*RAD)); 
   
   anim_LP2DOOR1 = CreateAnimation (0);      
  AddAnimationComponent  (anim_LP2DOOR1, 0, 1, &landpad2door1);   

//SIDEPADDOOR

  	static UINT EGrp23[3] = {GRP_pad2door2,GRP_pad2door2a, GRP_pad2door2b };//pad2
 static MGROUP_ROTATE landpad2door2 (0,EGrp23, 3, _V(-683.81,0,69.81), _V(0,1,0), (float)(-30*RAD)); ;
   
   anim_LP2DOOR2 = CreateAnimation (0);      
  AddAnimationComponent  (anim_LP2DOOR2, 0, 1, &landpad2door2);     	

//SIDEPADDOOR

  	static UINT EGrp24[3] = {GRP_pad3door1,GRP_pad3door1a,GRP_pad3door1b };//pad3
   static MGROUP_ROTATE  landpad3door1 (0,EGrp24, 3, _V( -678.70, 0,-280.51), _V(0,1,0), (float)(45*RAD)); ;
   
   anim_LP3DOOR1 = CreateAnimation (0);      
  AddAnimationComponent  (anim_LP3DOOR1, 0, 1, &landpad3door1);   

//SIDEPADDOOR

  	static UINT EGrp25[3] = {GRP_pad3door2,GRP_pad3door2a, GRP_pad3door2b };//pad3
   static MGROUP_ROTATE  landpad3door2 (0,EGrp25, 3, _V( -678.70, 0,-280.51), _V(0,1,0), (float)(-45*RAD)); ;
   
   anim_LP3DOOR2 = CreateAnimation (0);      
  AddAnimationComponent  (anim_LP3DOOR2, 0, 1, &landpad3door2);     	

//SIDEPADDOOR  
  	static UINT EGrp26[3] = {GRP_pad4door1,GRP_pad4door1a, GRP_pad4door1b };//pad4
   static MGROUP_ROTATE  landpad4door1 (0,EGrp26, 3, _V(157.03, 0, -619.50), _V(0,1,0), (float)(-45*RAD)); ;
   
   anim_LP4DOOR1 = CreateAnimation (0);      
  AddAnimationComponent  (anim_LP4DOOR1, 0, 1, &landpad4door1);   

//SIDEPADDOOR
  	static UINT EGrp27[3] = {GRP_pad4door2,GRP_pad4door2a,GRP_pad4door2b  };//pad4
   static MGROUP_ROTATE  landpad4door2 (0,EGrp27, 3, _V(157.03, 0, -619.50), _V(0,1,0), (float)(45*RAD)); ;
   
   anim_LP4DOOR2 = CreateAnimation (0);      
  AddAnimationComponent  (anim_LP4DOOR2, 0, 1, &landpad4door2);       
  		
//SIDEPADDOOR
  	static UINT EGrp28[3] = {GRP_pad5door1,GRP_pad5door1a,GRP_pad5door1b };//pad5
   static MGROUP_ROTATE  landpad5door1 (0,EGrp28, 3, _V( 781.51,0, 28.08), _V(0,1,0), (float)(-45*RAD)); ;
   
   anim_LP5DOOR1 = CreateAnimation (0);      
  AddAnimationComponent  (anim_LP5DOOR1, 0, 1, &landpad5door1);   

//SIDEPADDOOR
  	static UINT EGrp29[3] = {GRP_pad5door2,GRP_pad5door2a,GRP_pad5door2b};//pad5
   static MGROUP_ROTATE  landpad5door2 (0,EGrp29, 3, _V(781.51,0, 28.08), _V(0,1,0), (float)(45*RAD)); ;
   
   anim_LP5DOOR2 = CreateAnimation (0);      
  AddAnimationComponent  (anim_LP5DOOR2, 0, 1, &landpad5door2);  	    
 //PADUPPERDOOR
  	static UINT EGrp30[2] = {GRP_pad1updoor1,GRP_pad1updoor1b };//pad1
   static MGROUP_TRANSLATE uppad1door1 (0,EGrp30, 3, _V(0,0,30));
   
   anim_ULP1DOOR1 = CreateAnimation (0);      
  AddAnimationComponent  (anim_ULP1DOOR1, 0, 1, &uppad1door1);   
 //PADUPPERDOOR

  	static UINT EGrp31[2] = {GRP_pad1updoor2,GRP_pad1updoor2b};//pad1
   static MGROUP_TRANSLATE uppad1door2 (0,EGrp31, 2, _V(0,0,-30));
   
   anim_ULP1DOOR2 = CreateAnimation (0);      
  AddAnimationComponent  (anim_ULP1DOOR2, 0, 1, &uppad1door2);     	 
 //PADUPPERDOOR
   	static UINT EGrp32[2] = {GRP_pad2updoor1,GRP_pad2updoor1b};//pad2
   static MGROUP_TRANSLATE uppad2door1 (0,EGrp32, 2, _V(0,0,30));
   
   anim_ULP2DOOR1 = CreateAnimation (0);      
  AddAnimationComponent  (anim_ULP2DOOR1, 0, 1, &uppad2door1);   

 //PADUPPERDOOR
  	static UINT EGrp33[2] = {GRP_pad2updoor2,GRP_pad2updoor2b};//pad2
   static MGROUP_TRANSLATE uppad2door2 (0,EGrp33, 2, _V(0,0,-30));
   
   anim_ULP2DOOR2 = CreateAnimation (0);      
  AddAnimationComponent  (anim_ULP2DOOR2, 0, 1, &uppad2door2);     	  
 //PADUPPERDOOR  
 	static UINT EGrp34[2] = {GRP_pad3updoor1,GRP_pad3updoor1b };//pad3
   static MGROUP_TRANSLATE uppad3door1 (0,EGrp34, 2, _V(0,0,30));
   
   anim_ULP3DOOR1 = CreateAnimation (0);      
  AddAnimationComponent  (anim_ULP3DOOR1, 0, 1, &uppad3door1);   

 //PADUPPERDOOR
  	static UINT EGrp35[2] = {GRP_pad3updoor2,GRP_pad3updoor2b};//pad3
   static MGROUP_TRANSLATE uppad3door2 (0,EGrp35, 2, _V(0,0,-30));
   
   anim_ULP3DOOR2 = CreateAnimation (0);      
  AddAnimationComponent  (anim_ULP3DOOR2, 0, 1, &uppad3door2);     	  
       
 //PADUPPERDOOR	
 	static UINT EGrp36[2] = {GRP_pad4updoor1,GRP_pad4updoor1b};//pad4
   static MGROUP_TRANSLATE uppad4door1 (0,EGrp36, 2, _V(0,0,30));
   
   anim_ULP4DOOR1 = CreateAnimation (0);      
  AddAnimationComponent  (anim_ULP4DOOR1, 0, 1, &uppad4door1);   

 //PADUPPERDOOR
  	static UINT EGrp37[2] = {GRP_pad4updoor2,GRP_pad4updoor2b};//pad4
   static MGROUP_TRANSLATE uppad4door2 (0,EGrp37, 2, _V(0,0,-30));
   
   anim_ULP4DOOR2 = CreateAnimation (0);      
  AddAnimationComponent  (anim_ULP4DOOR2, 0, 1, &uppad4door2);
  //PADUPPERDOOR 
   	static UINT EGrp38[2] = {GRP_pad5updoor1 ,GRP_pad5updoor1b};//pad5
   static MGROUP_TRANSLATE uppad5door1 (0,EGrp38, 2, _V(0,0,30));
   
   anim_ULP5DOOR1 = CreateAnimation (0);      
  AddAnimationComponent  (anim_ULP5DOOR1, 0, 1, &uppad5door1);   

 //PADUPPERDOOR
  	static UINT EGrp39[2] = {GRP_pad5updoor2,GRP_pad5updoor2b};//pad5
   static MGROUP_TRANSLATE uppad5door2 (0,EGrp39, 2, _V(0,0,-30));
   
   anim_ULP5DOOR2 = CreateAnimation (0);      
  AddAnimationComponent  (anim_ULP5DOOR2, 0, 1, &uppad5door2);
//hangarairlockdoors


  	static UINT EGrp41[4] = {GRP_AIRLOCK1DOORA,GRP_AIRLOCK1DOORB,GRP_AIRLOCK1DOORC,GRP_AIRLOCK1DOORD};//airlock1
   static MGROUP_TRANSLATE DDOOR1 (0,EGrp41, 4, _V(.932,0,1.235));
   
   anim_DD0 = CreateAnimation (0);      
  AddAnimationComponent  (anim_DD0, 0, 1, &DDOOR1);   
  	
  	static UINT EGrp43[4] = {GRP_AIRLOCK2DOORA,GRP_AIRLOCK2DOORB,GRP_AIRLOCK2DOORC,GRP_AIRLOCK2DOORD};//airlock2
   static MGROUP_TRANSLATE DDOOR2 (0,EGrp43, 4, _V(-2,0,0));
   
   anim_DD1 = CreateAnimation (0);      
  AddAnimationComponent  (anim_DD1, 0, 1, &DDOOR2); 

    
  	static UINT EGrp45[4] = {GRP_AIRLOCK3DOORA,GRP_AIRLOCK3DOORB,GRP_AIRLOCK3DOORC,GRP_AIRLOCK3DOORD};//airlock3
   static MGROUP_TRANSLATE DDOOR3 (0,EGrp45, 4, _V(-2,0,0));
   
   anim_DD2 = CreateAnimation (0);      
  AddAnimationComponent  (anim_DD2, 0, 1, &DDOOR3);   
  
 
 	static UINT EGrp47[4] = {GRP_AIRLOCK4DOORA,GRP_AIRLOCK4DOORB,GRP_AIRLOCK4DOORC,GRP_AIRLOCK4DOORD};//airlock4
   static MGROUP_TRANSLATE DDOOR4 (0,EGrp47, 4, _V(-2,0,0));
   
   anim_DD3 = CreateAnimation (0);      
  AddAnimationComponent  (anim_DD3, 0, 1, &DDOOR4);   
  
        
	static UINT EGrp49[4] = {GRP_AIRLOCK5DOORA,GRP_AIRLOCK5DOORB,GRP_AIRLOCK5DOORC,GRP_AIRLOCK5DOORD};//airlock5
   static MGROUP_TRANSLATE DDOOR5 (0,EGrp49, 4, _V(-2,0,0));
   
   anim_DD4 = CreateAnimation (0);      
  AddAnimationComponent  (anim_DD4, 0, 1, &DDOOR5);   


ANIMATIONCOMPONENT_HANDLE parent;  
//CARGOBAYEXTERIORDOOR
  	static UINT EGrp78[1] = {GRP_CARGODOORLEFT2};//cargodoor1
	static UINT EGrp79[1] = {GRP_CARGODOORLEFT1};//cargodoor2
   static MGROUP_TRANSLATE cdoor (0,EGrp79, 1, _V(5,0,0));
CARGOBAYdoor = new MGROUP_TRANSLATE (0,EGrp78, 1, _V( 5,0,0));
   
   anim_CARGOBAYDOOR = CreateAnimation (0); 
  parent = AddAnimationComponent(anim_CARGOBAYDOOR,.5,1.0,&cdoor);
   anim_CARGOBAYDOORA = CreateAnimation (0); 
  AddAnimationComponent  (anim_CARGOBAYDOORA, 0, .5, CARGOBAYdoor,parent);
  
ANIMATIONCOMPONENT_HANDLE parent1;
	
  	static UINT EGrp88[1] = {GRP_CARGODOORRIGHT2};//cargodoor1
	static UINT EGrp89[1] = {GRP_CARGODOORRIGHT1};//cargodoor2
   static MGROUP_TRANSLATE cdoor1 (0,EGrp89, 1, _V(-5,0,0));
CARGOBAYdoor1 = new MGROUP_TRANSLATE (0,EGrp88, 1, _V(- 5,0,0));
   
   anim_CARGOBAYDOOR1 = CreateAnimation (0); 
  parent1 = AddAnimationComponent(anim_CARGOBAYDOOR1,.5,1.0,CARGOBAYdoor1);

  AddAnimationComponent  (anim_CARGOBAYDOOR1, 0, .5, &cdoor1,parent1);

}
DLLCLBK VESSEL *ovcInit (OBJHANDLE hvessel, int flightmodel)
{
return new MBA (hvessel, flightmodel);
}

DLLCLBK void ovcExit (VESSEL *vessel)
{
if (vessel) delete (MBA*)vessel;
}

// --------------------------------------------------------------
// Keyboard interface handler (buffered key events)
// --------------------------------------------------------------
int MBA::clbkConsumeBufferedKey(DWORD key, bool down, char *kstate)
{
	// only process keydown events
	if (!down) 
		return 0; 

	//---------------------------------------------------------------------------
	// Ummu Key "E" perform the EVA of the selected member
	if(key==OAPI_KEY_E)
	{
		// PERFORM THE EVA
		
		int Returned=EvaCrewMemberWithStandardSpacesuit(Crew.GetCrewNameBySlotNumber(SelectedUmmuMember));
		
		switch(Returned)
		{
		case TRANSFER_TO_DOCKED_SHIP_OK:
			sprintf(SendFocusScreenMessage(),"Transfer to docked ship Ok - %s transfered",Crew.GetLastEvaedCrewName());SelectedUmmuMember=0;
			break;
		case EVA_OK:
			sprintf(SendFocusScreenMessage(),"EVA OK - %s left the ship",Crew.GetLastEvaedCrewName());SelectedUmmuMember=0;
			break;
		case ERROR_NO_ONE_ON_BOARD:
			strcpy(SendFocusScreenMessage(),"Error, no one on board, unable to EVA");
			break;
		case ERROR_AIRLOCK_CLOSED:
			strcpy(SendFocusScreenMessage(),"Error, airlock is closed, unable to EVA");
			break;
		case ERROR_DOCKED_SHIP_HAVE_AIRLOCK_CLOSED:
			strcpy(SendFocusScreenMessage(),"Error, docked ship's airlock is closed, unable to transfer");
			break;
		case ERROR_DOCKED_SHIP_IS_FULL:
			strcpy(SendFocusScreenMessage(),"Error, docked ship is already full transfer failed");
			break;
		case ERROR_CREW_MEMBER_NOT_FOUND:
			strcpy(SendFocusScreenMessage(),"Error, no crew by this name in ship");
			break;
		case ERROR_DOCKEDSHIP_DONOT_USE_UMMU:
			strcpy(SendFocusScreenMessage(),"Error, docked ship do not use UMmu 1.5, ask author to add it See http://orbiter.dansteph.com");
			break;
		case ERROR_MISC_ERROR_EVAFAILED:
			strcpy(SendFocusScreenMessage(),"Misc error with UMMU See http://orbiter.dansteph.com to install it again");
			break;
		}
		return TRUE;
	}

	//---------------------------------------------------------------------------
	// Ummu Key "1" Select next member This is just internal to the demo
	if(key==OAPI_KEY_1)
	{
		// we test there is someone aboard
		if(Crew.GetCrewTotalNumber()==0)
		{
			strcpy(SendFocusScreenMessage(),"Sorry no one aboard unable to select");	
			return 1;
		}

		// we test that we select existing member
		if(SelectedUmmuMember<Crew.GetCrewTotalNumber()-1)
			SelectedUmmuMember++;
		char * Name=Crew.GetCrewNameBySlotNumber(SelectedUmmuMember);
		sprintf(SendFocusScreenMessage(),"Slot %i  %s \"%s\" aged %i Selected for EVA or Transfer, please press \"E\" to EVA \"ESC\" to eject",SelectedUmmuMember,Crew.GetCrewMiscIdBySlotNumber(SelectedUmmuMember),Name,Crew.GetCrewAgeBySlotNumber(SelectedUmmuMember));
		return 1;
	}

	//---------------------------------------------------------------------------
	// Ummu Key "2" Select previous member This is just internal to the demo
	if(key==OAPI_KEY_2)
	{
		// we test there is someone aboard
		if(Crew.GetCrewTotalNumber()==0)
		{
			strcpy(SendFocusScreenMessage(),"Sorry no one aboard unable to select");	
			return 1;
		}
		if(SelectedUmmuMember>0)
			SelectedUmmuMember--;
		char * Name=Crew.GetCrewNameBySlotNumber(SelectedUmmuMember);
		sprintf(SendFocusScreenMessage(),"Slot %i %s \"%s\" aged %i Selected for EVA or Transfer, please press \"E\" to EVA \"ESC\" to eject",SelectedUmmuMember,Crew.GetCrewMiscIdBySlotNumber(SelectedUmmuMember),Name,Crew.GetCrewAgeBySlotNumber(SelectedUmmuMember));
		return 1;
	}


	// Ummu Key "A" Switch the airlock door on/off
	if(key==OAPI_KEY_A)
	{		// switch state
		Crew.SetAirlockDoorState(!Crew.GetAirlockDoorState());
		// display state
		if (doorselected==0)
		{RevertDD0 ();
		PlayVesselWave3(MARSBASEID,AIRLOCKCLOSE,NOLOOP,255);
		if(Crew.GetAirlockDoorState()==TRUE)
		{strcpy(SendFocusScreenMessage(),"Pad Airlock1 is now open");	
		}
		else
		{strcpy(SendFocusScreenMessage(),"Pad Airlock1 is now closed");
	}}
if (doorselected==1)
{RevertDD1();
PlayVesselWave3(MARSBASEID,AIRLOCKCLOSE,NOLOOP,255);
if(Crew.GetAirlockDoorState()==TRUE)
		{strcpy(SendFocusScreenMessage(),"Pad Airlock2 is now open");	
		}
		else
		{strcpy(SendFocusScreenMessage(),"Pad Airlock2 is now closed");
	}}
if (doorselected==2)
{RevertDD2();
PlayVesselWave3(MARSBASEID,AIRLOCKCLOSE,NOLOOP,255);
if(Crew.GetAirlockDoorState()==TRUE)
		{strcpy(SendFocusScreenMessage(),"Pad Airlock3 is now open");	
		}
		else
		{strcpy(SendFocusScreenMessage(),"Pad Airlock3 is now closed");
	}}
if (doorselected==3)
{RevertDD3();
PlayVesselWave3(MARSBASEID,AIRLOCKCLOSE,NOLOOP,255);
if(Crew.GetAirlockDoorState()==TRUE)
		{strcpy(SendFocusScreenMessage(),"Pad Airlock4 is now open");	
		}
		else
		{strcpy(SendFocusScreenMessage(),"Pad Airlock4 is now closed");
	}}
if (doorselected==4)
{RevertDD4();
PlayVesselWave3(MARSBASEID,AIRLOCKCLOSE,NOLOOP,255);
if(Crew.GetAirlockDoorState()==TRUE)
		{strcpy(SendFocusScreenMessage(),"Pad Airlock5 is now open");	
		}
		else
		{strcpy(SendFocusScreenMessage(),"Pad Airlock5 is now closed");
	}}
	}
	

	//---------------------------------------------------------------------------
	// Eject the guy
	if(key==OAPI_KEY_ESCAPE)
	{
		if(Crew.EjectCrewMember(Crew.GetCrewNameBySlotNumber(SelectedUmmuMember))==EVA_OK)
			sprintf(SendFocusScreenMessage(),"%s EJECTED",Crew.GetLastEvaedCrewName());SelectedUmmuMember=0;
		return 1;
	}

	//---------------------------------------------------------------------------
	// Use a different Mesh (type "C" then EVA someone)
	if(key==OAPI_KEY_C)
	{
		Crew.SetAlternateMeshToUseForEVASpacesuit("mmu");	// the stock mmu of orbiter located in "meshes/mmu.msh"
		strcpy(SendFocusScreenMessage(),"Mesh changed");
		return 1;
	}

	//---------------------------------------------------------------------------
	// Get some infos Name of ship and total soul aboard
	if(key==OAPI_KEY_S)
	{
		sprintf(SendFocusScreenMessage(),"%i souls aboard ship %s, %i seats available",Crew.GetCrewTotalNumber(),GetName(),99-Crew.GetCrewTotalNumber());
		return 1;
	}

// change active dock
    if(key==OAPI_KEY_9)
    {
        switch(iActiveDockNumber)
		{
            case 0:
				{
                  iActiveDockNumber++; //go to port1
                  sprintf(SendFocusScreenMessage(),"Active dock number changed to: Airlock2");
                  SetUMMUAirlockPos();
				}
          break;
          case 1:
			  {
                  iActiveDockNumber++; //go to port2
                  sprintf(SendFocusScreenMessage(),"Active dock number changed to: Airlock3");
                  SetUMMUAirlockPos();
			  }
            break;
            case 2:
				{
                  iActiveDockNumber++; //go to port3
                  sprintf(SendFocusScreenMessage(),"Active dock number changed to: Airlock4");
                  SetUMMUAirlockPos();
				}
            break;
            case 3:
				{
                  iActiveDockNumber++; //go to port4
                  sprintf(SendFocusScreenMessage(),"Active dock number changed to: Airlock5");
                  SetUMMUAirlockPos();
				}
            break;
            case 4:
				{
                  iActiveDockNumber = 0; // go back to port0
                  sprintf(SendFocusScreenMessage(),"Active dock number changed to: Airlock1");
                  SetUMMUAirlockPos();
				}
            break;
		}}

    //---------------------------------------------------------------------------
    // change active dock
    if(key==OAPI_KEY_0)
	{
switch(iActiveDockNumber)
        {
            case 0:
            {
                  iActiveDockNumber=4; //go to port4
                  sprintf(SendFocusScreenMessage(),"Active dock number changed to: Airlock5");
                  SetUMMUAirlockPos();
            }
          break;
          case 1:
            {
                  iActiveDockNumber--; //go to port0
                  sprintf(SendFocusScreenMessage(),"Active dock number changed to: Airlock1");
                  SetUMMUAirlockPos();
            }
            break;
            case 2:
            {
                  iActiveDockNumber--; //go to port1
                  sprintf(SendFocusScreenMessage(),"Active dock number changed to: Airlock2");
                  SetUMMUAirlockPos();
            }
            break;
            case 3:
            {
                  iActiveDockNumber--; //go to port2
                  sprintf(SendFocusScreenMessage(),"Active dock number changed to: Airlock3");
                  SetUMMUAirlockPos();
            }
            break;
            case 4:
            {
                  iActiveDockNumber--; // go to port3
                  sprintf(SendFocusScreenMessage(),"Active dock number changed to: Airlock4");
                  SetUMMUAirlockPos();
            }
            break;
}
    }
           
if(key==OAPI_KEY_G) // pad elevator, pad upper doors must be open

     {	if ((APSel==0)&(ULP1D_proc==1))
{PlayVesselWave3(MARSBASEID,ELEVATOR,NOLOOP,255);
	RevertLP();}
if ((APSel==1)&(ULP2D_proc==1))
{PlayVesselWave3(MARSBASEID,ELEVATOR,NOLOOP,255);
RevertLP();}
if ((APSel==2)&(ULP3D_proc==1))
{PlayVesselWave3(MARSBASEID,ELEVATOR,NOLOOP,255);
RevertLP();}
if ((APSel==3)&(ULP4D_proc==1))
{PlayVesselWave3(MARSBASEID,ELEVATOR,NOLOOP,255);
RevertLP();}
if ((APSel==4)&(ULP1D_proc==1))
{PlayVesselWave3(MARSBASEID,ELEVATOR,NOLOOP,255);
RevertLP();}
			return 1;
		}

if(key==OAPI_KEY_D) // side hangar doors
{RevertLPdoor();
PlayVesselWave3(MARSBASEID,DOORCLOSE,NOLOOP,255);
			return 1;
}		
if(key==OAPI_KEY_O) // Upper pad doors, pad must be down
   {	if ((APSel==0)&(LP1_proc==0))
{PlayVesselWave3(MARSBASEID,AIRLOCKCLOSE,NOLOOP,255);
	RevertDOCKdoor();}
if ((APSel==1)&(LP2_proc==0))
{PlayVesselWave3(MARSBASEID,AIRLOCKCLOSE,NOLOOP,255);
	RevertDOCKdoor();}
if ((APSel==2)&(LP3_proc==0))
{PlayVesselWave3(MARSBASEID,AIRLOCKCLOSE,NOLOOP,255);
	RevertDOCKdoor();}
if ((APSel==3)&(LP4_proc==0))
{PlayVesselWave3(MARSBASEID,AIRLOCKCLOSE,NOLOOP,255);
	RevertDOCKdoor();}
if ((APSel==4)&(LP5_proc==0))
{PlayVesselWave3(MARSBASEID,AIRLOCKCLOSE,NOLOOP,255);
	RevertDOCKdoor();}
 


			return 1;
		}
if(key==OAPI_KEY_V)
{
    CAM = CAM + 1;
    if(CAM > 7) CAM = 0;
        SelectCockpitView(CAM);
        return 1;
}
if(key==OAPI_KEY_K) // ATTACH
{  do_attach = 1;
             AttachCargo();
             return 1;
}

if(key==OAPI_KEY_N)//cargobay
{
        RevertCARGOBAY();
             return 1;		
}


if(key==OAPI_KEY_J)//JETTISON
{
         DetachCargo();
             return 1;		
}
	if(key==OAPI_KEY_W)// SELECT
            {APSel = APSel + 1;
             if(APSel > 4) APSel = 0;
            //turn them all off first
            for (int i = 0; i < 5; i++) {
                APbeacon[i].active = false;
            }
            //Turn on the selected one
            APbeacon[int(APSel)].active = true;
            //sprintf(oapiDebugString(),"anim %2.2f", APSel );
            
            return 1;
        }
return 0;
}

// ====================================================================
// clbkVisualCreated used to display UMMU initialisation message 
// because oapiDebugString() doesn't work in clbkSetClassCap
// ====================================================================
void MBA::clbkVisualCreated (VISHANDLE vis, int refcount)
{   
	MainExternalMeshVisual = GetMesh(vis,0);
	// We warn the user, in the case UMmu isn't installed it's a good idea to send a "oapiDebugString"
	// Orbiter message, otherwise your addon will not be fully operational and user may not notice. 
	//(nobody read doc, you may be the only one, if you read this send me a postcard ;)
	if(UmmuSdKInitReturnCode==-999)
		strcpy(SendFocusScreenMessage(),"This addon require UMMU addon wich is not installed or outdated. See http://orbiter.dansteph.com to install it");
	else if(UmmuSdKInitReturnCode!=1)
		strcpy(SendFocusScreenMessage(),"Misc error with UMMU See http://orbiter.dansteph.com to install it again");
	// just for the demo
	else if(UmmuSdKInitReturnCode==1)
		strcpy(SendFocusScreenMessage(),"Welcome aboard. UMMU Keys:  E=EVA 1=&2=select member A=close/open airlock ESC=eject S=get ship info 9/0 switch airlocks");
}
// ==============================================================
// Visual destroyed
// ==============================================================
void MBA::clbkVisualDestroyed (VISHANDLE vis, int refcount)
{
	MainExternalMeshVisual = 0;	
}


void MBA::RevertCARGOBAY (void)
{
	CARGOBAY_status = ((CARGOBAY_status == HATCH_UP || CARGOBAY_status == HATCH_RAISING) ?
		HATCH_LOWERING : HATCH_RAISING);
}
void MBA::RevertDD0 (void)
{
	DD0_status = ((DD0_status == HATCH_UP || DD0_status == HATCH_RAISING) ?
		HATCH_LOWERING : HATCH_RAISING);
}
void MBA::RevertDD1 (void)
{
	DD1_status = ((DD1_status == HATCH_UP || DD1_status == HATCH_RAISING) ?
		HATCH_LOWERING : HATCH_RAISING);
}
void MBA::RevertDD2 (void)
{
	DD2_status = ((DD2_status == HATCH_UP || DD2_status == HATCH_RAISING) ?
		HATCH_LOWERING : HATCH_RAISING);
}
void MBA::RevertDD3 (void)
{
	DD3_status = ((DD3_status == HATCH_UP || DD3_status == HATCH_RAISING) ?
		HATCH_LOWERING : HATCH_RAISING);
}
void MBA::RevertDD4 (void)
{
	DD4_status = ((DD4_status == HATCH_UP || DD4_status == HATCH_RAISING) ?
		HATCH_LOWERING : HATCH_RAISING);
}
void MBA::AttachCargo(){
             VECTOR3 aphpos, aphdir, aphrot, gaph;
             VECTOR3 shippos, shipdir, shiprot, gpship;

             // get attachment point positions based on selected point
             switch (int(APSel)) {
                case 0:
                    GetAttachmentParams(LP1,aphpos, aphdir, aphrot);
                 break;
                case 1:
                    GetAttachmentParams(LP2,aphpos, aphdir, aphrot);
                   break;
                case 2: 
                     GetAttachmentParams(LP3,aphpos, aphdir, aphrot);
                   break;
                   case 3:
                    GetAttachmentParams(LP4,aphpos, aphdir, aphrot);
                   break;
                case 4: 
                     GetAttachmentParams(LP5,aphpos, aphdir, aphrot);
                   break;
              }  
             // change the position to a global one rather then a local one. This will allow me to offset it from the local center.
             // the local position is stored in gaph
             Local2Global (aphpos, gaph);

             //I now know were the attach point is in the global world
             //Now lets find out if there is a skid in range
             // Search the complete vessel list for a grappling candidate.
            // Not very scalable ...
                for (DWORD i = 0; i < oapiGetVesselCount(); i++) {
                    OBJHANDLE hV = oapiGetVesselByIndex (i);    //get handle for ship
        //            if (strncmp (hV->GetClassName(), "QJFFS", 5)!=0  ){  //restrict to only QuadJ ships to make it easy.

                    // Look for any ship with a child attach point. This allows the Mule to grap any object
                    if (hV == GetHandle()) continue; // If self then continue onward because we don't want to grapple ourselves ...

                    oapiGetGlobalPos (hV, &gpship); // get global postion of ship and put into gpship


                       VESSEL *v = oapiGetVesselInterface (hV);
                       // Only look for child attach point
                       DWORD nAttach = v->AttachmentCount (true); //Get attachment count. I do this so that I can grap any child point.
                       if (nAttach > 0){ // Only continue if ship has a child attach point
                           for (DWORD j = 0; j < nAttach; j++) { // now scan all attachment points of the candidate and check how far away from the attach point it is
                               ATTACHMENTHANDLE hAtt = v->GetAttachmentHandle (true, j);
                               /* this would allow me to filter out all but QJ ships but I don't want to right now
                               const char *id = v->GetAttachmentId (hAtt);
                               if (strncmp (id, "GS", 2)) continue; // attachment point not compatible
                               */
                               v->GetAttachmentParams (hAtt, shippos, shipdir, shiprot); //lets get the attach point position
                               v->Local2Global (shippos, gpship); // and change it to a global position Recycle of gpship cause I can
                               if (dist (gpship, gaph) < MAX_GRAP_DIST) { // Is it close enough to grab?
                                   apd = dist(gpship, gaph);
                                   // Yes! Then lets grab the little bugger and get out of here
                                   const char *id = v->GetAttachmentId (hAtt);
								   (do_attach=0);
								   if(!strncmp (id, "APR", 3))
								   {do_attach=1;}
								   else if (!strncmp (id, "VAP", 3))
										{do_attach=1;}
									else if (!strncmp (id, "VAC", 3))
										{do_attach=1;}
				   
								   if(do_attach > 0){
                                     

                                       switch (int(APSel)) {
                                         case 0:
                                               AttachChild (hV, LP1, hAtt);
                                               break;
                                         case 1:
                                               AttachChild (hV, LP2, hAtt);
                                               break;
                                         case 2:
                                               AttachChild (hV, LP3, hAtt);
                                                break;
                                       case 3:
                                               AttachChild (hV, LP4, hAtt);
                                               break;
                                         case 4:
                                               AttachChild (hV, LP5, hAtt);
                                   }
                                   }
                                  return;
								   }}
                            } // End of for j
                       }
                    }
                

void MBA::DetachCargo ()
{
    switch (int(APSel)) {
        case 0:
             DetachChild(LP1,2.2);
             break;
             case 1:
             DetachChild(LP2,2.2);
             break;
             case 2:
             DetachChild(LP3,2.2);
             break;
             case 3:
             DetachChild(LP4,2.2);
             break;
             case 4:
             DetachChild(LP5,2.2);
             break;
}}









void MBA::RevertLP (void)
{if (APSel==0){
{
	LP1_status = ((LP1_status == HATCH_UP || LP1_status == HATCH_RAISING) ?
		HATCH_LOWERING : HATCH_RAISING);
}}
if (APSel==1){
{
	LP2_status = ((LP2_status == HATCH_UP || LP2_status == HATCH_RAISING) ?
		HATCH_LOWERING : HATCH_RAISING);
}}
if (APSel==2){
{
	LP3_status = ((LP3_status == HATCH_UP || LP3_status == HATCH_RAISING) ?
		HATCH_LOWERING : HATCH_RAISING);
}}
if (APSel==3){
{
	LP4_status = ((LP4_status == HATCH_UP || LP4_status == HATCH_RAISING) ?
		HATCH_LOWERING : HATCH_RAISING);
}}
if (APSel==4){
{
	LP5_status = ((LP5_status == HATCH_UP || LP5_status == HATCH_RAISING) ?
		HATCH_LOWERING : HATCH_RAISING);
}}

}

void MBA::HUD_Text(const HUDPAINTSPEC* pHPS, HDC hdc)
{
  char cbuf[128];
//  char cbuf2[128];
  int n, tx, ty, ty2, yoff, bs, ap,n1,ty3,ty4;
  double apd;
  GetTextMetrics(hdc, &tm);
  yoff = tm.tmHeight;
  tx = tm.tmAveCharWidth;
  ty4 = 10 * yoff;
  ty3 = 9 * yoff;
  ty = 10 * yoff;
  ty2 = 11 * yoff;

  //Rectangle (hdc, tx-2, ty-1, tx+120,ty+(yoff*7));
  SetTextColor (hdc, colRed);
  n1 = sprintf (cbuf, "CAMERA: %d", (CAM));
  TextOut(hdc,tx,ty3,cbuf,n1 );
   if (CAM==0) {n=sprintf (cbuf, "External ");
  TextOut(hdc,tx+100,ty3,cbuf,n );}
  if (CAM==1) {n=sprintf (cbuf, "Pad#1 ");
  TextOut(hdc,tx+100,ty3,cbuf,n );}
   if (CAM==2) {n=sprintf (cbuf, "Pad#2 ");
  TextOut(hdc,tx+100,ty3,cbuf,n );}
  if (CAM==3) {n=sprintf (cbuf, "Pad#3");
  TextOut(hdc,tx+100,ty3,cbuf,n );}
  
  if (CAM==4) {n=sprintf (cbuf, "Pad#4 ");
  TextOut(hdc,tx+100,ty3,cbuf,n );}
 if (CAM==5) {n=sprintf (cbuf, "Pad#5 ");
  TextOut(hdc,tx+100,ty3,cbuf,n );}
 if (CAM==6) {n=sprintf (cbuf, "Pad#6");
  TextOut(hdc,tx+100,ty3,cbuf,n );}
 if (CAM==7) {n=sprintf (cbuf, "Cargo Bay ");
  TextOut(hdc,tx+100,ty3,cbuf,n );}






  SetTextColor (hdc, colDodgerBlue);

  n = sprintf (cbuf, "Landing Pad Selected: %d", (APSel+1));
  TextOut(hdc,tx,ty,cbuf,n );

  
  
  
  TextOut(hdc,tx,ty2,"LANDING PAD STATUS",18);
bs=0;
  
    //Launch/attachment point status display Left Bay
    
       



       
            
sprintf (cbuf, "1: ");
TextOut(hdc,(tx),(ty2 + (yoff*1))+3,cbuf,strlen(cbuf) );
        if(GetAttachmentStatus(LP1)){
           oapiGetObjectName (GetAttachmentStatus(LP1), cbuf, 100);
        }else{
           sprintf (cbuf, "-----");
        }
          TextOut(hdc,(tx+14),(ty2 + (yoff*1))+3,cbuf,strlen(cbuf) );
       
sprintf (cbuf, "2: ");
TextOut(hdc,(tx),(ty2 + (yoff*2))+3,cbuf,strlen(cbuf) );          
          
          if(GetAttachmentStatus(LP2)){
           oapiGetObjectName (GetAttachmentStatus(LP2), cbuf, 100);
        }else{
           sprintf (cbuf, "-----");
        }
               TextOut(hdc,(tx+14),(ty2 + (yoff*2))+3,cbuf,strlen(cbuf) );

                       
sprintf (cbuf, "3: ");
TextOut(hdc,(tx),(ty2 + (yoff*3))+3,cbuf,strlen(cbuf) );
                
                	 if(GetAttachmentStatus(LP3)){
           oapiGetObjectName (GetAttachmentStatus(LP3), cbuf, 100);
        }else{
           sprintf (cbuf, "-----");
        }
        TextOut(hdc,(tx+14),(ty2 + (yoff*3))+3,cbuf,strlen(cbuf) );
       
sprintf (cbuf, "4: ");
TextOut(hdc,(tx),(ty2 + (yoff*4))+3,cbuf,strlen(cbuf) );
          
                    if(GetAttachmentStatus(LP4)){
           oapiGetObjectName (GetAttachmentStatus(LP4), cbuf, 100);
        }else{
           sprintf (cbuf, "-----");
        }
                TextOut(hdc,(tx+14),(ty2 + (yoff*4))+3,cbuf,strlen(cbuf) );
       
sprintf (cbuf, "5: ");
TextOut(hdc,(tx),(ty2 + (yoff*5))+3,cbuf,strlen(cbuf) );
         if(GetAttachmentStatus(LP5)){
           oapiGetObjectName (GetAttachmentStatus(LP5), cbuf, 100);
        }else{
           sprintf (cbuf, "-----");
        }
                TextOut(hdc,(tx+14),(ty2 + (yoff*5))+3,cbuf,strlen(cbuf) );  
  
 }
void MBA::clbkDrawHUD(int iMode, const HUDPAINTSPEC* pHPS, HDC hdc)
{
	VESSEL2::clbkDrawHUD(iMode, pHPS, hdc);
	HUD_Text(pHPS, hdc);
}
void MBA::RevertLPdoor (void)
{if (APSel==0){
{
	LP1D_status = ((LP1D_status == HATCH_UP || LP1D_status == HATCH_RAISING) ?
		HATCH_LOWERING : HATCH_RAISING);
}}
if (APSel==1){
{
	LP2D_status = ((LP2D_status == HATCH_UP || LP2D_status == HATCH_RAISING) ?
		HATCH_LOWERING : HATCH_RAISING);
}}
if (APSel==2){
{
	LP3D_status = ((LP3D_status == HATCH_UP || LP3D_status == HATCH_RAISING) ?
		HATCH_LOWERING : HATCH_RAISING);
}}
if (APSel==3){
{
	LP4D_status = ((LP4D_status == HATCH_UP || LP4D_status == HATCH_RAISING) ?
		HATCH_LOWERING : HATCH_RAISING);
}}
if (APSel==4){
{
	LP5D_status = ((LP5D_status == HATCH_UP || LP5D_status == HATCH_RAISING) ?
		HATCH_LOWERING : HATCH_RAISING);
}}

}


void MBA::RevertDOCKdoor (void)
{if (APSel==0){
{
	ULP1D_status = ((ULP1D_status == HATCH_UP || ULP1D_status == HATCH_RAISING) ?
		HATCH_LOWERING : HATCH_RAISING);
}}
if (APSel==1){
{
	ULP2D_status = ((ULP2D_status == HATCH_UP || ULP2D_status == HATCH_RAISING) ?
		HATCH_LOWERING : HATCH_RAISING);
}}
if (APSel==2){
{
	ULP3D_status = ((ULP3D_status == HATCH_UP || ULP3D_status == HATCH_RAISING) ?
		HATCH_LOWERING : HATCH_RAISING);
}}
if (APSel==3){
{
	ULP4D_status = ((ULP4D_status == HATCH_UP || ULP4D_status == HATCH_RAISING) ?
		HATCH_LOWERING : HATCH_RAISING);
}}
if (APSel==4){
{
	ULP5D_status = ((ULP5D_status == HATCH_UP || ULP5D_status == HATCH_RAISING) ?
		HATCH_LOWERING : HATCH_RAISING);
}}

}


// ========================================================================
// clbkLoadState function of Orbiter - Save scenario when user exit Orbiter 
// ========================================================================
void MBA::clbkSaveState(FILEHANDLE scn)
{

	// ORBITER, default vessel parameters
	SaveDefaultState (scn);

	// UMmu, this will save all our members of crew in scenario
	// as airlock state depend of your ship (you may have a real animated airlock)
	// it's your responsabilites to save and reload UMmu's airlock state.
	Crew.SaveAllMembersInOrbiterScenarios(scn);
}
// ========================================================================
// clbkLoadStateEx function of Orbiter - Load Orbiter scenario 
// ========================================================================
void MBA::clbkLoadStateEx (FILEHANDLE scn, void *status)
{
	char *line;
	while (oapiReadScenario_nextline (scn, line)) 
	{

		// UMMU, Load all saved member from scenario. 
		// Return TRUE when a "UMMUCREW" line is encountered 
		// FALSE when it must pass this line to you or default parser
		if(Crew.LoadAllMembersFromOrbiterScenario(line)==TRUE)
			continue;

		// ORBITER, unrecognised option - pass to Orbiter's generic parser
		ParseScenarioLineEx (line, status);
	}

}
//------------------------------------------------------------------------------------------------------------------
// This below is not mandatory for UMmu to run.
//------------------------------------------------------------------------------------------------------------------

// ==========================================================
// USING TEXT INTERFACE FOR CREW MANAGMENT (not a good idea)
//
// This is the custom functions that send oapiDebugString() Message on screen
// it simply avoid that the message is sent if our ship don't have the focus
// and ensure that message will be reminded when we focus back on ship
// the Orbiter function below clbkFocusChanged is used to erase message when
// we lost focus.
// It's a bad idea to do an UMmu user interface only by using Debug screen message 
// but if you can't do better you may use this system.
///////////////////////////////////////////////////////////////////////////////////////////
char *MBA::SendFocusScreenMessage()
{
	return cOurMessage;
}
void MBA::clbkFocusChanged(bool getfocus,OBJHANDLE hNewVessel,OBJHANDLE hOldVessel)
{
	// erase message if we focus to another vessel
	if(!getfocus)
	{
		strcpy(oapiDebugString(),"");
	}
}
// ================================================================
// HUD (I put the anim state on the hud because in Poststep
// it forbids ummu messages to be displayed).
// ================================================================


// ==========================================================================================
// USING STANDARD FUNCTION ID,NAME AND SPACESUIT (Good idea)
// **TEST: replace "Crew.EvaCrewMember" with this function in clbkConsumeBufferedKey (key E)**
// ==========================================================================================
int MBA::EvaCrewMemberWithStandardSpacesuit(char* CrewName)
{
	char TempMiscID[5]={0};
	int I=0;
	char MeshToUse[26]={"ummu"}; // default mesh if not found
	// retriew the crew's MiscID
	strcpy(TempMiscID,Crew.GetCrewMiscIdByName(CrewName));
	// search if we find this ID in the list
	for(I=0;I<NUMBER_OF_MMU_TYPE;I++)
	{
		if(strcmp(UmmuMiscID[I],TempMiscID)==0)
		{
			// found ! copy the mesh filename to use for EVA
			strcpy(MeshToUse,UmmuMeshUsed[I]);
			break;
		}
	}
	// Set the mesh filename to use
	Crew.SetAlternateMeshToUseForEVASpacesuit(MeshToUse);
	// Eva the crew member with this mesh
	return Crew.EvaCrewMember(CrewName);
}
